package com.googlecode.mycontainer.commons.rhino;

import org.mozilla.javascript.tools.debugger.Main;
import org.mozilla.javascript.tools.shell.Global;

public class RhinoDebugShell extends RhinoShell {

	private static final Runnable EXIT_ACTION = new Runnable() {

		public void run() {
			System.exit(0);
		}

	};

	private final Main main;

	public RhinoDebugShell(RhinoBox box) {
		super(box);
		main = new Main("RhinoBox Debugger");
		main.setBreakOnEnter(true);

		Global global = (Global) getBox().getScope().getScope();
		global.setIn(main.getIn());
		global.setOut(main.getOut());
		global.setErr(main.getErr());

		main.attachTo(RhinoBox.getContextFactory());

		main.setScope(global);
	}

	public Main getMain() {
		return main;
	}

	@Override
	public void execute() {
		main.pack();
		main.setSize(600, 460);
		main.setVisible(true);
		super.execute();
	}

	public static void main(String[] args) {
		RhinoDebugShell shell = new RhinoDebugShell(DefaultRhinoBoxBuilder
				.instance().getGlobalInstance());
		shell.getMain().setExitAction(EXIT_ACTION);
		shell.execute();
	}
}
