package com.googlecode.mycontainer.commons.util;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

import com.googlecode.mycontainer.commons.io.IOUtil;

public class ZipUtil {

	public static byte[] gzip(String str, String charset) {
		try {
			byte[] data = str.getBytes(charset);
			return gzip(data);
		} catch (UnsupportedEncodingException e) {
			throw new RuntimeException(e);
		}
	}

	public static byte[] gzip(byte[] data) {
		try {
			ByteArrayOutputStream bout = new ByteArrayOutputStream();
			GZIPOutputStream out = new GZIPOutputStream(bout);
			out.write(data);
			out.close();
			return bout.toByteArray();
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

	public static String gunzipString(byte[] gz, String string) {
		try {
			byte[] data = gunzip(gz);
			return new String(data, string);
		} catch (UnsupportedEncodingException e) {
			throw new RuntimeException(e);
		}
	}

	private static byte[] gunzip(byte[] gz) {
		try {
			GZIPInputStream in = new GZIPInputStream(new ByteArrayInputStream(
					gz));
			byte[] ret = IOUtil.readAll(in);
			return ret;
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

}
